# coding: utf-8

"""
    Schema API - OpenAPI 3.1

    This is a Schema extraction API based on the OpenAPI 3.1 specification.  You can find out more about Swagger at [https://swagger.io](https://swagger.io). 

    The version of the OpenAPI document: 0.2.0
    Contact: philipp.schmurr@kit.edu
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json




from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from simpler_model.models.attribute import Attribute
from simpler_model.models.entity_modifier import EntityModifier
from simpler_model.models.relation import Relation
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Entity(BaseModel):
    """
    Entity
    """ # noqa: E501
    entity_name: Annotated[List[StrictStr], Field(min_length=1)] = Field(alias="entityName")
    has_attribute: Optional[List[Attribute]] = Field(default=None, alias="hasAttribute")
    has_entity_modifier: Optional[List[EntityModifier]] = Field(default=None, alias="hasEntityModifier")
    is_object_in_relation: Optional[List[Relation]] = Field(default=None, alias="isObjectInRelation")
    is_subject_in_relation: Optional[List[Relation]] = Field(default=None, alias="isSubjectInRelation")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["entityName", "hasAttribute", "hasEntityModifier", "isObjectInRelation", "isSubjectInRelation"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Entity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
                "additional_properties",
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in has_attribute (list)
        _items = []
        if self.has_attribute:
            for _item in self.has_attribute:
                if _item:
                    _items.append(_item.to_dict())
            _dict['hasAttribute'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in is_object_in_relation (list)
        _items = []
        if self.is_object_in_relation:
            for _item in self.is_object_in_relation:
                if _item:
                    _items.append(_item.to_dict())
            _dict['isObjectInRelation'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in is_subject_in_relation (list)
        _items = []
        if self.is_subject_in_relation:
            for _item in self.is_subject_in_relation:
                if _item:
                    _items.append(_item.to_dict())
            _dict['isSubjectInRelation'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of Entity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "entityName": obj.get("entityName"),
            "hasAttribute": [Attribute.from_dict(_item) for _item in obj.get("hasAttribute")] if obj.get("hasAttribute") is not None else None,
            "hasEntityModifier": obj.get("hasEntityModifier"),
            "isObjectInRelation": [Relation.from_dict(_item) for _item in obj.get("isObjectInRelation")] if obj.get("isObjectInRelation") is not None else None,
            "isSubjectInRelation": [Relation.from_dict(_item) for _item in obj.get("isSubjectInRelation")] if obj.get("isSubjectInRelation") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


